program PipeSrv;

// Delphi 2.0 Pipe server that echoes input after having uppercased it.
// Console application.
//
// JHJe 1996-12-04

uses
  Windows, SysUtils, PipeObjs;

const
  CR = #13;
  LF = #10;
  CRLF = CR + LF;

var
  Pipe: TPipeServer;
  BrokenPipe: Boolean;
  buf: AnsiString;
  sa: TSecurityAttributes;

begin
  writeln('Halt with ^C');
  // Set NIL security
  sa.nLength:= sizeOf(sa);
  sa.bInheritHandle:= false;
  sa.lpSecurityDescriptor:= nil;
  while true do begin
    try
      Pipe:= TPipeServer.Create('\\.\pipe\TestServer', sa);
    except
      on E: Exception do begin
        writeln(E.Message);
        halt(1);
      end;
    end;
    { Wait for client to connect }
    if not Pipe.Connect then begin
      Writeln('Connect failed');
      Pipe.Destroy;
      halt(2);
    end;
    { Client is connected, process input }
    writeln('Client has connected!');
    BrokenPipe:= false;
    repeat
      try
        Pipe.ReadStr(buf);
      except
        BrokenPipe:= true;
      end;
      if not BrokenPipe then
        Pipe.WriteStr(UpperCase(buf));
    until BrokenPipe;
    { Clean up }
    Pipe.Free;
  end; // while
end.
